﻿namespace Pikta.Editor.Tests
{
    using System;
    using System.Linq;
    using Microsoft.VisualStudio.TestTools.UnitTesting;

    [TestClass]
    public class SceneTest
    {
        private static Scene scene;

        [ClassInitialize]
        public static void ClassInitialize(TestContext context)
        {
            scene = new Scene(Namespace.Global);
        }

        [TestMethod]
        public void EnumerateElementsBreadth()
        {
            var ns = Namespace.Global;

            var expected = new[]
                {
                    ns[KnownNames.Root],
                    ns["ObsahRootu"],
                    ns["Obdélník1"],
                    ns["Elipsa1"],
                    ns["Popiska"],
                    ns["MojeŽlutá"]
                };
            var actual = scene.EnumerateElementsBreadth(scene.Root).ToArray();

            CollectionAssert.AreEqual(expected, actual);
        }

        [TestMethod]
        public void GetContainersOf()
        {
            var ns = Namespace.Global;

            var expected = new[]
                {
                    ns[KnownNames.Root],
                    ns["ObsahRootu"],
                    ns["Obdélník1"]
                };
            var actual = scene.GetSuperElementsOf(ns["MojeŽlutá"]).ToArray();

            CollectionAssert.AreEqual(expected, actual);
        }
    }
}
