﻿namespace Pikta.Editor.Actions
{
    using System;
    using System.Collections.Generic;
    using System.Diagnostics.Contracts;
    using System.Linq;
    using System.Text;
    using Pikta.Expressions;

    public class AddPropertyAction : HistoryAction
    {
        public AddPropertyAction(Property property, Expression value)
        {
            Contract.Requires(property != null);
            Contract.Requires(value != null);

            base.Name = "Přidání vlastnosti " + property;
            base.PerformAction = () => property.Value = value;
            base.UndoAction = property.Remove;
        }
    }
}
