﻿namespace Pikta.Editor.Actions
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using Pikta.Expressions;

    public class ChangePropertyValueAction : HistoryAction
    {
        public ChangePropertyValueAction(Property property, Expression newValue, IPropertyState originalState = null)
        {
            base.Name = "Změna hodnoty " + property;

            if (originalState == null)
            {
                originalState = property.CaptureState();
            }

            base.PerformAction = () => property.Value = newValue;
            base.UndoAction = () => originalState.Restore();
        }
    }
}
