﻿namespace Pikta.Editor.Actions
{
    using System;
    using System.Collections.Generic;
    using System.Diagnostics.Contracts;
    using System.Linq;
    using System.Text;

    public class MoveElementAction : HistoryAction
    {
        public MoveElementAction(Scene scene, Element element, Element targetContainer)
        {
            Contract.Requires(scene != null);
            Contract.Requires(element != null);
            Contract.Requires(targetContainer != null);
            Contract.Requires(targetContainer.IsContainer());

            Element sourceContainer = scene.GetParentContainer(element);

            base.Name = string.Format("Přesun elementu {0} z {1} do {2}", element, sourceContainer, targetContainer);

            int sourceIndex = sourceContainer.GetContainerChildren().IndexOf(element);

            base.PerformAction = () =>
                {
                    sourceContainer.GetContainerChildren().RemoveAt(sourceIndex);
                    targetContainer.GetContainerChildren().Add(element);
                };

            base.UndoAction = () =>
                {
                    targetContainer.GetContainerChildren().Remove(element);
                    sourceContainer.GetContainerChildren().Insert(sourceIndex, element);
                };
        }
    }
}
