﻿namespace Pikta.Editor.Actions
{
    using System;
    using System.Collections.Generic;
    using System.Diagnostics.Contracts;
    using System.Linq;
    using System.Text;

    public class MoveElementToPositionAction : HistoryAction
    {
        public MoveElementToPositionAction(Scene scene, Element element, int targetIndex)
        {
            Contract.Requires(scene != null);
            Contract.Requires(element != null);
            Contract.Requires(targetIndex >= 0);

            var collection = scene.GetParentContainer(element).GetContainerChildren();

            base.Name = string.Format("Přesun elementu {0} na pozici {1}", element, targetIndex);

            int sourceIndex = collection.IndexOf(element);

            base.PerformAction = () =>
            {
                collection.RemoveAt(sourceIndex);
                collection.Insert(targetIndex, element);
            };

            base.UndoAction = () =>
            {
                collection.RemoveAt(targetIndex);
                collection.Insert(sourceIndex, element);
            };
        }
    }
}
