﻿namespace Pikta.Editor.Actions
{
    using System;
    using System.Collections.Generic;
    using System.Diagnostics.Contracts;
    using System.Linq;
    using System.Text;

    public class RemovePropertyAction : HistoryAction
    {
        public RemovePropertyAction(Property property)
        {
            Contract.Requires(property != null);

            var definice = property.Definition;

            base.Name = string.Format("Odebrání vlastnosti {0}", property);

            base.PerformAction = property.Remove;

            base.UndoAction = () =>
                {
                    definice.Element[definice.Name].Value = definice.Value;
                };
        }
    }
}
