﻿namespace Pikta.Editor
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.Data;
    using System.Drawing;
    using System.Linq;
    using System.Text;
    using System.Windows.Forms;
    using Pikta.Expressions;

    public partial class AddElementForm : Form
    {
        public AddElementForm()
        {
            InitializeComponent();
        }

        public string ElementName
        {
            get { return this.nameTextBox.Text.Trim(); }
            set { this.nameTextBox.Text = value; }
        }

        public IEnumerable<Element> AvailablePrototypes
        {
            get { return (IEnumerable<Element>)this.prototypeListBox.DataSource; }
            set { this.prototypeListBox.DataSource = value.OrderBy(e => e.ToString(), NameComparer.Instance).ToArray(); }
        }

        public Element Prototype
        {
            get { return (Element)this.prototypeListBox.SelectedItem; }
            set { this.prototypeListBox.SelectedItem = value; }
        }

        private void addButton_Click(object sender, EventArgs e)
        {
            if (ElementName.Length > 0)
            {
                if (!Parser.IsValidElementName(ElementName))
                {
                    Program.ShowInfo("Zadaný název elementu není platný.");
                    this.nameTextBox.Select();
                    return;
                }
            }

            if (Prototype == null)
            {
                Program.ShowInfo("Vyberte prototyp pro nový element.");
                this.prototypeListBox.Select();
                return;
            }

            DialogResult = DialogResult.OK;
        }
    }
}
