﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;

namespace Pikta.Editor
{
	public class Box : Shape
	{
		public Box()
			: base("Obdélník")
		{
		}

		public override void DrawElement(Graphics g, Element e, Rectangle container)
		{
			// ziskame parametry
			var sirka = GetWidth(e);
			var vyska = GetHeight(e);

            var plocha = new Rectangle(container.Location, new Size(sirka, vyska));

            OnRectangleChanged(e, plocha);

			// vypln
            using (var s = GetFill(e))
            {
                g.FillRectangle(s, plocha);
            }

			// okraj
			using(var p = GetStroke(e))
			{
				g.DrawRectangle(p, plocha);
			}
		}
	}
}
