﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Linq;
using System.Text;

namespace Pikta.Editor
{
    public abstract class ContainerVisual : Shape
    {
        private readonly IVisualProvider visualProvider;

        public ContainerVisual(string prototypeName, IVisualProvider visualProvider)
            : base(prototypeName)
        {
            this.visualProvider = visualProvider;
        }

        protected GraphicsState ClipToRegion(Graphics g, Region region)
        {
            var state = g.Save();
            var clipped = new Region(g.Clip.GetRegionData());
            clipped.Intersect(region);
            g.Clip = clipped;
            return state;
        }

        protected Visual GetHandler(Element element)
        {
            return this.visualProvider.GetHandler(element);
        }

        protected IEnumerable<Element> GetContent(Element container)
        {
            return container.GetContainerChildren();
        }
    }
}
