﻿namespace Pikta.Editor
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using System.Windows.Forms;

    /// <summary>
    /// Obsluha tažení myší ovlivňující element.
    /// </summary>
    public abstract class DraggingHandler
    {
        protected DraggingHandler(Scene scene, View view, Element element)
        {
            this.Scene = scene;
            this.View = view;
            this.Element = element;
        }

        protected Scene Scene { get; private set; }
        protected View View { get; private set; }
        protected Element Element { get; private set; }

        public virtual void Start(MouseEventArgs e)
        {
            View.Cursor = Cursors.SizeAll;
        }

        public virtual void Move(MouseEventArgs e)
        {
        }

        public virtual void Finish(MouseEventArgs e)
        {
            View.Cursor = Cursors.Default;
        }
    }
}