﻿namespace Pikta.Editor
{
    using System;
    using System.Collections.Generic;
    using System.Diagnostics.Contracts;
    using System.Linq;
    using System.Text;

    public class ElementMoveEventArgs : EventArgs
    {
        public ElementMoveEventArgs(Element sourceElement, Element targetContainer)
        {
            Contract.Requires(sourceElement != null);
            Contract.Requires(targetContainer != null);
            Contract.Requires(targetContainer.IsContainer());

            this.SourceElement = sourceElement;
            this.TargetContainer = targetContainer;
        }

        public Element SourceElement { get; private set; }

        public Element TargetContainer { get; private set; }
    }
}
