﻿namespace Pikta.Editor
{
    using System;
    using System.Collections.Generic;
    using System.Diagnostics.Contracts;
    using System.Linq;
    using System.Text;

    public class ElementMoveToPositionEventArgs : EventArgs
    {
        public ElementMoveToPositionEventArgs(Element sourceElement, int targetPosition)
        {
            Contract.Requires(sourceElement != null);
            Contract.Requires(targetPosition > 0);

            this.SourceElement = sourceElement;
            this.TargetPosition = targetPosition;
        }

        public Element SourceElement { get; private set; }

        public int TargetPosition { get; private set; }
    }
}
