﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;

namespace Pikta.Editor
{
    public class Ellipse : Shape
    {
        public Ellipse()
			: base("Elipsa")
		{
		}

		public override void DrawElement(Graphics g, Element e, Rectangle container)
		{
			// ziskame parametry
			var sirka = GetWidth(e);
			var vyska = GetHeight(e);

            var plocha = new Rectangle(container.Location, new Size(sirka, vyska));

            OnRectangleChanged(e, plocha);

			// vypln
            using (var s = GetFill(e))
            {
                g.FillEllipse(s, plocha);
            }

			// okraj
			using(var p = GetStroke(e))
			{
				g.DrawEllipse(p, plocha);
			}
		}
    }
}
