﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Pikta.Expressions;

namespace Pikta.Editor
{
    public partial class GenerateGridForm : Form
    {
        public GenerateGridForm()
        {
            InitializeComponent();
        }

        public string GeneratedName
        {
            get { return this.nameTextBox.Text; }
            set { this.nameTextBox.Text = value; }
        }

        public IEnumerable<Element> AvailableGridTemplates
        {
            get { return (IEnumerable<Element>)this.gridTemplateComboBox.DataSource; }
            set { this.gridTemplateComboBox.DataSource = value.ToArray(); }
        }

        public Element GridTemplate
        {
            get { return (Element)this.gridTemplateComboBox.SelectedItem; }
            set { this.gridTemplateComboBox.SelectedItem = value; }
        }

        public int Rows
        {
            get { return (int)this.rowsNumericUpDown.Value; }
            set { this.rowsNumericUpDown.Value = value; }
        }

        public int Columns
        {
            get { return (int)this.columnsNumericUpDown.Value; }
            set { this.columnsNumericUpDown.Value = value; }
        }

        public IEnumerable<Element> AvailableItemTemplates
        {
            get { return (IEnumerable<Element>)this.itemTemplateComboBox.DataSource; }
            set { this.itemTemplateComboBox.DataSource = value.ToArray(); }
        }

        public Element ItemTemplate
        {
            get { return (Element)this.itemTemplateComboBox.SelectedItem; }
            set { this.itemTemplateComboBox.SelectedItem = value; }
        }

        private void generateButton_Click(object sender, EventArgs e)
        {
            if (this.nameTextBox.TextLength > 0)
            {
                if (!Parser.IsValidElementName(this.nameTextBox.Text))
                {
                    Program.ShowInfo("Zadaný název generované mřížky není platný.");
                    this.nameTextBox.Select();
                    return;
                }

                if (Namespace.Global.Contains(this.nameTextBox.Text))
                {
                    Program.ShowError(string.Format("Element s názvem \"{0}\" již existuje.", this.nameTextBox.Text));
                    this.nameTextBox.Select();
                    return;
                }
            }

            if (this.ItemTemplate == null)
            {
                Program.ShowInfo("Vyberte prototyp položky, jejímiž klony se naplní vygenerovaná mřížka.");
                this.itemTemplateComboBox.Select();
                return;
            }

            DialogResult = DialogResult.OK;
        }
    }
}
