﻿namespace Pikta.Editor
{
    using System;
    using System.Collections.Generic;
    using System.Drawing;
    using System.Linq;
    using System.Text;

    public class Generator : Visual
    {
        private readonly IVisualProvider visualProvider;

        public Generator(IVisualProvider visualProvider)
            : base(KnownNames.Generator)
        {
            this.visualProvider = visualProvider;
        }

        public override void DrawElement(Graphics g, Element e, Rectangle container)
        {
            Element result = GetResult(e);
            this.visualProvider.GetHandler(result).DrawElement(g, result, container);
        }

        private Element GetResult(Element e)
        {
            return e.GetElement("výsledek", Element.Base);
        }
    }
}
