﻿namespace Pikta.Tests
{
    using System;
    using System.Globalization;
    using System.Linq;
    using Microsoft.VisualStudio.TestTools.UnitTesting;
    using Pikta.Expressions;

    [TestClass]
    public class ExpressionTest
    {
        [TestMethod]
        public void AllConstants()
        {
            Expression expr = Parser.Parse("-10 + 25 + (haba.kuk % 15)", CultureInfo.InvariantCulture);

            var expected = new[] { 10.0, 25, 15 };
            var actual = expr.AllConstants.Select(c => (double)c.Value).ToArray();

            CollectionAssert.AreEqual(expected, actual);
        }

        [TestMethod]
        public void AllSymbols()
        {
            Expression expr = Parser.Parse("-.prvni + 25 + (haba.kuk % Druhy)", CultureInfo.InvariantCulture);

            var expected = new[] { ".prvni", "haba.kuk", "Druhy" };
            var actual = expr.AllSymbolExpressions.Select(s => s.ToString()).ToArray();

            CollectionAssert.AreEqual(expected, actual);
        }
    }
}
