﻿using System;
using System.Globalization;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Pikta.Expressions;

namespace Pikta.Tests
{
    [TestClass]
    public class ExpressionToStringTest
    {
        private CultureInfo IC { get { return CultureInfo.InvariantCulture; } }

        [TestMethod]
        public void SymbolsRoundtrip()
        {
            // konstanty
            TestRoundtrip("123");
            TestRoundtrip("123456789");
            TestRoundtrip("\"Řetězec\"");
            
            // symboly
            TestRoundtrip("Element");
            TestRoundtrip(".šířka");
            TestRoundtrip("Element.Levý.šířka");
            TestRoundtrip(".šířka + .výška");

            // artitmetika
            TestRoundtrip(".šířka / 2");
            TestRoundtrip("18 + 34 - (27 + 5) / 2012");
        }

        private void TestRoundtrip(string expression)
        {
            Expression vyraz = Parser.Parse(expression, IC);
            Assert.AreEqual(vyraz, Parser.Parse(vyraz.ToString(), IC), "Výraz \"" + expression + "\" nebyl správně převeden zpět.");
        }
    }
}
