﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;

namespace Pikta.Expressions
{
	public abstract class ArithmeticBinaryExpression : BinaryExpression
	{
		protected ArithmeticBinaryExpression(string op, Expression left, Expression right)
			: base(left, right)
		{
			Operator = op;
		}

		private string Operator { get; set; }

		public override string ToString()
		{
            return ToString(CultureInfo.CurrentCulture);
		}

        public override string ToString(IFormatProvider formatProvider)
        {
            return string.Format(formatProvider, "({0} {1} {2})", Left.ToString(formatProvider), Operator, Right.ToString(formatProvider));
        }
	}
}
