﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Pikta.Expressions
{
	/// <summary>
	/// Výraz, jehož výpočtem vznikne hodnota.
	/// </summary>
	public abstract class Expression : IEquatable<Expression>
	{
		/// <summary>Vrátí všechny symbolické podvýrazy, které se vyskytují v tomto výrazu.</summary>
		public abstract IEnumerable<SymbolExpression> AllSymbolExpressions { get; }

        /// <summary>Returns all constant subexpressions that are part of this expression.</summary>
        public abstract IEnumerable<Constant> AllConstants { get; }

		#region IEquatable<Expression> Members

		public abstract bool Equals(Expression other);

		#endregion

        public abstract string ToString(IFormatProvider formatProvider);
	}
}
