﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;

namespace Pikta.Expressions
{
	public class Negation : UnaryExpression
	{
		public Negation(Expression subexpression) : base(subexpression) { }

		public bool Equals(Negation other)
		{
			return other != null && base.Equals(other);
		}

		public override bool Equals(Expression other)
		{
			return Equals(other as Negation);
		}

		public override bool Equals(object obj)
		{
			return Equals(obj as Negation);
		}

		public override int GetHashCode()
		{
			return -Subexpression.GetHashCode();
		}

		public override string ToString()
        {
            return ToString(CultureInfo.CurrentCulture);
        }

        public override string ToString(IFormatProvider formatProvider)
        {
            return string.Format(formatProvider, "-{0}", Subexpression.ToString(formatProvider));
        }
	}
}
