﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Pikta.Expressions
{
	public abstract class UnaryExpression : Expression
	{
		protected UnaryExpression(Expression subexpression)
		{
			Subexpression = subexpression;
		}

		public Expression Subexpression { get; private set; }

		public override IEnumerable<SymbolExpression> AllSymbolExpressions { get { return Subexpression.AllSymbolExpressions; } }

        public override IEnumerable<Constant> AllConstants
        {
            get { return Subexpression.AllConstants; }
        }

		public bool Equals(UnaryExpression other)
		{
			return other != null && other.Subexpression.Equals(Subexpression);
		}

		public override bool Equals(Expression other)
		{
			return Equals(other as UnaryExpression);
		}
	}
}
