﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Pikta
{
	/// <summary>
	/// Porovnávač názvů elementů a vlastností.
	/// </summary>
	/// <remarks>
	/// Při porovnávání názvů se nerozlišuje velikost písmen.
	/// </remarks>
	public class NameComparer : IEqualityComparer<string>, IComparer<string>
	{
        public bool Equals(string x, string y) { return StringComparer.OrdinalIgnoreCase.Equals(x, y); }

		public int GetHashCode(string obj) { return StringComparer.OrdinalIgnoreCase.GetHashCode(obj); }

		private static Lazy<NameComparer> _Instance = new Lazy<NameComparer>();
		public static NameComparer Instance { get { return _Instance.Value; } }

		public int Compare(string x, string y)
		{
			if(x == null)
				return y == null ? 0 : -1;
			else if(y == null)
				return 1;
			else
                return string.Compare(x, y, StringComparison.OrdinalIgnoreCase);
		}
	}
}
