﻿namespace Pikta
{
    using System;
    using System.Collections.Generic;
    using System.Diagnostics.Contracts;
    using System.Linq;
    using System.Text;
    using Pikta.Expressions;

    public static class PropertyExtensions
    {
        public static IPropertyState CaptureState(this Property property)
        {
            return new CapturedPropertyState(property);
        }

        private class CapturedPropertyState : IPropertyState
        {
            private readonly Property property;
            private readonly Expression originalValue;

            public CapturedPropertyState(Property property)
            {
                Contract.Requires(property != null);

                this.property = property;
                this.originalValue = property.IsLocal ? property.Value : null;
            }

            public void Restore()
            {
                if (this.originalValue != null)
                {
                    this.property.Value = this.originalValue;
                }
                else
                {
                    this.property.Remove();
                }
            }
        }
    }
}
