﻿namespace Pikta
{
    using System.Collections.Generic;
    using System.Runtime.CompilerServices;

    public sealed class ReferenceEqualityComparer<T> : EqualityComparer<T>
        where T : class
    {
        private readonly static ReferenceEqualityComparer<T> instance = new ReferenceEqualityComparer<T>();

        public static IEqualityComparer<T> Instance { get { return instance; } }

        public override bool Equals(T x, T y)
        {
            return object.ReferenceEquals(x, y);
        }

        public override int GetHashCode(T obj)
        {
            return RuntimeHelpers.GetHashCode(obj);
        }
    }
}
